#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASGetCallHistory : public CWASCommand
{
public:
	CWASGetCallHistory(CWASActor *pActor);
	~CWASGetCallHistory(void);

	void ExecuteAsync(void);

	void SetParameter(NTCallType eCallType, LPCWSTR strLangCode)
	{
		m_eCallType = eCallType;
		m_strLangCode = strLangCode;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:
	NTCallType m_eCallType;
	WSTRING m_strLangCode;

	std::vector<NE_CALL_DATA> m_listCallHistory;

};




class CWASSetCallInfo : public CWASCommand
{
public:
	CWASSetCallInfo(CWASActor *pActor);
	~CWASSetCallInfo(void);

	void ExecuteAsync(void);

	void SetParameter(NE_CALL_DATA sCallData)
	{
		m_sCallData = sCallData;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:
	NE_CALL_DATA	m_sCallData;
	int				m_nCallSeq;
};
